
var contentWin; 			//ventana que esta actualmente abierta
var xmlfiletree;			//xml con la estructura de ficheros
var xmlextensions;	//xml con las extensiones del proyecto


//Ventanas Emergentes

//Rename file
function show_renamefile_window(path) {
	//alert("show_renamefile_window: "+path);
	if (contentWin == null) {
		//Configuramos la ventana
		contentWin = new Window({className: "mac_os_x", title: "Rename file", width:265, height:100, minimizable: false, maximizable: false, destroyOnClose: true, recenterAuto:true, resizable:false});

		// Set up a windows observer, check ou debug window to get messages
		myObserver = {
			onDestroy: function() {
				//Vaciamos el contenido de la ventana
				var window_content = document.getElementById("window_content");
				window_content.innerHTML = "";
				
				//Quitamos la veladura de fondo
				var layer_off = document.getElementById('layer_off');
				layer_off.style.display = 'none';
				//document.body.removeChild(layer_off);
				
				//Eliminamos la ventana
				contentWin = null;
				//document.body.removeChild(win); 
				Windows.removeObserver(this);
			},
			
			/*
			onClose: function() {
				document.body.removeChild(layer_off);
				document.body.removeChild(win); 
			}
			*/
			
			
			onShow: function() {
				//Ponemos la veladura de fondo
				var layer_off = document.getElementById('layer_off');
				layer_off.style.display = 'block';
				layer_off.style.width = document.body.offsetWidth+"px";
				layer_off.style.height = document.body.offsetHeight+"px";
			}
			
		}
		
		Windows.addObserver(myObserver);
		
		
		//Nos quedamos con el nombre del fichero
		var file_name = path.substring(path.lastIndexOf("/")+1, path.length);
		
		//Creamos las partes del contenido de la ventana
		var window_content = document.getElementById('window_content');
		window_content.innerHTML = ''+
		'<div id="window_rename_content">'+
			'<table>'+
				'<tr>'+
					'<td>'+
						'Name: '+
					'</td>'+
					'<td>'+
						'<input type="text" id="name_file" style="width:200px" value="'+file_name+'" /> '+
					'</td>'+
				'</tr>'+
				'<tr>'+
					'<td colspan="2" height="10"></td>'+
				'</tr>'+
				'<tr>'+
					'<td colspan="2" align="center">'+
						'<input type="button" value="OK" onclick="submit_rename_file(\''+path+'\')" style="width:70px;" />'+
						'&nbsp;&nbsp;&nbsp;&nbsp;'+
						'<input type="button" value="Cancel" onclick="contentWin.close()" style="width:70px;" />'+
					'</td>'+
				'</tr>'+
			'</table>'+
		'</div>';
	
		//Mostramos la ventana
		contentWin.setContent('window_content');
		contentWin.showCenter();
		
	}
}


function submit_rename_file(path_file) {
	//Obtenemos el nombre del fichero
	var file_name = document.getElementById('name_file').value;
	
	//Chequeamos el nombre del fichero
	var error = false;
	if (file_name == "") {
		error = true;
	}
	
	//Si se ha puesto nombre
	if (!error) {
		//Obtenemos el path
		//alert(path_file);
		var path = path_file.substring(0, path_file.lastIndexOf("/")+1);
		var newpath_file = path+file_name;
		//alert(newpath_file);
		
		//Comprobamos que no existe ya un fichero con ese nuevo nombre
		if (file_exists(newpath_file)) {
			alert("File exists. Imposible to rename this file.");
		}
		else {
			//Llamamos a la accion
			rename_file(path_file, newpath_file);
		}
	}
}



//New file window
function show_newfile_window(path) {
	//alert("show_newfile_window: "+path);

	if (contentWin == null) {

		//Configuramos la ventana
		contentWin = new Window({className: "mac_os_x", title: "New file", width:475, height:320, minimizable: false, maximizable: false, destroyOnClose: true, recenterAuto:true, resizable:false});

		// Set up a windows observer, check ou debug window to get messages
		myObserver = {
			onDestroy: function() {
				//Vaciamos el contenido de la ventana
				var window_content = document.getElementById("window_content");
				window_content.innerHTML = "";
				
				//Quitamos la veladura de fondo
				var layer_off = document.getElementById('layer_off');
				layer_off.style.display = 'none';
				//document.body.removeChild(layer_off);
				
				//Eliminamos la ventana
				contentWin = null;
				//document.body.removeChild(win); 
				Windows.removeObserver(this);
			},
			
			onShow: function() {
				//Ponemos la veladura de fondo
				var layer_off = document.getElementById('layer_off');
				layer_off.style.display = 'block';
				layer_off.style.width = document.body.offsetWidth+"px";
				layer_off.style.height = document.body.offsetHeight+"px";
			}
			
		}
		
		Windows.addObserver(myObserver);
		
		//Creamos las partes del contenido de la ventana
		var window_content = document.getElementById('window_content');
		window_content.innerHTML = ''+
			'<div id="window_file_explorer">Loading...</div>'+
			'<div id="window_file_data"></div>';
	
		//Mostramos la ventana
		contentWin.setContent('window_content');
		contentWin.showCenter();
		
		//Obtenemos el xml con la estructura de ficheros
		xmlfiletree = get_xmlfiletree(path);
		
		//Obtenemos el xml con las extensiones del proyecto
		if (xmlextensions == null) {
			xmlextensions = get_xmlextensions();
		}
		
		//Generamos el contenido del explorador de ficheros
		update_window_file_explorer('window_file_explorer', path);
	
		//Generamos el contenido de los datos del nuevo fichero
		update_window_file_data('window_file_data');
		
	}
}

//Actualiza la zona de exploracion de ficheros de la ventana
function update_window_file_explorer(id, path) {
	//alert("update_window_file_explorer: "+path);
	
	//Mostramos el contenido de precarga antes de cargar
	document.getElementById(id).innerHTML = "Loading...";

	
	var contentHTML = 'Folder: ';
	contentHTML += '<select id="path_newfile" style="width:300px" onchange="update_window_file_explorer(\''+id+'\', this.options[this.selectedIndex].value)">';
	
	//Obtenemos la lista de carpetas por encima de nuestro nivel
	var folder_array = path.split("/");
	var separator = "";
	//var path_value = "..";
	//var path_value = folder_array[0]+"/"+folder;
	var path_value = path_user; //Variable global
	
	for (var i=3; i<folder_array.length; i++) {
		//alert(i+": "+folder_array[i]);
		if (i == folder_array.length-1) {
			//contentHTML += '<option value="'+folder_array[i]+'" onclick="update_window_file_explorer(\''+id+'\', \''+path_value+'/'+folder_array[i]+'\')" selected>'+separator+folder_array[i]+'</option>';
			contentHTML += '<option value="'+path_value+'/'+folder_array[i]+'" selected>'+separator+folder_array[i]+'</option>';
		}
		else {
			//contentHTML += '<option value="'+folder_array[i]+'" onclick="update_window_file_explorer(\''+id+'\', \''+path_value+"/"+folder_array[i]+'\')">'+separator+folder_array[i]+'</option>';
			contentHTML += '<option value="'+path_value+'/'+folder_array[i]+'">'+separator+folder_array[i]+'</option>';
		}
		path_value += '/'+folder_array[i];
		//alert(path_value);
		separator += '&nbsp;&nbsp;';
	}
	contentHTML += '</select>';
	
				
	//Obtenemos los ficheros para esa carpeta 
	contentHTML += '<div id="file_explorer" >';
	
	var folder = getFolderByPath(xmlfiletree, path);
	var nodes = folder.childNodes;
	for(var i=0; i<nodes.length; i++) {
		
		var type = nodes[i].getAttribute('type');
		var name = unescape(nodes[i].getAttribute('name'));
		var path = unescape(nodes[i].getAttribute('path'));
		var image = unescape(nodes[i].getAttribute('image'));

		if (type == "dir") {
			contentHTML += '<div class="file_item" ondblclick="update_window_file_explorer(\''+id+'\', \''+path+'\')" unselectable="on"><img src="../images/folder.gif" align="absmiddle"> '+name+'</div>';
		}
		else {
			contentHTML += '<div class="file_item" onclick="set_name_window_file_data(\''+name+'\')" unselectable="on" ><img src="'+image+'" align="absmiddle"> '+name+'</div>';
		}
	}
	contentHTML += '</div>';
	
	//Mostramos el contenido una vez cargado
	document.getElementById(id).innerHTML = contentHTML;
		
		
}


//Actualiza la seccion de los datos del fichero
function update_window_file_data(id) {
	document.getElementById(id).innerHTML = "Loading...";

	//Mostramos los tipos de ficheros
	var selectHTML = '<select id="extension_newfile" style="width:200px">';
				
	var nodes = xmlextensions.childNodes;
	for(var i=0; i<nodes.length; i++) {
		var name = nodes[i].getAttribute('name');
		var description = nodes[i].getAttribute('description');
		if (i==0) {
			selectHTML += '<option value="'+name+'" selected>'+description+' (*.'+name+')</option>';
		}
		else {
			selectHTML += '<option value="'+name+'">'+description+' (*.'+name+')</option>';
		}
	}
	selectHTML += '</select>';


	//Mostramos el campo donde poner el nombre dle fichero
	var contentHTML = ''+
										'<table>'+
											'<tr>'+
												'<td>'+
													'Name: '+
												'</td>'+
												'<td>'+
													'<input id="name_newfile" type="text" style="width:196px"></input>'+
												'</td>'+
												'<td>'+
													'<input type="submit" value="OK" onclick="submit_new_file()" style="width:70px" />'+
												'</td>'+
											'</tr>'+
											'<tr>'+
												'<td>'+
													'File type: '+
												'</td>'+
												'<td>'+
													selectHTML+
												'</td>'+
												'<td>'+
													'<input type="reset" value="Cancel" onclick="contentWin.close()" style="width:70px" />'+
												'</td>'+
											'</tr>'+
										'</table>';

	//Mostramos el contenido una vez cargado
	document.getElementById(id).innerHTML = contentHTML;
	
}



//Establece el nombre del fichero en el campo de la ventana
function set_name_window_file_data(name) {
	var sort_name = name.substr(0,name.lastIndexOf('.'));
	document.getElementById('name_newfile').value = sort_name;
}


function submit_new_file () {
	var element;
	//Obtenemos el nombre del fichero
	element = document.getElementById('name_newfile');
	var file_name = element.value;
	
	//Chequeamos el nombre del fichero
	var error = false;
	if (file_name == "") {
		error = true;
	}
	
	
	//Si se ha puesto nombre
	if (!error) {
		//Obtenemos del path
		element = document.getElementById('path_newfile');
		var file_path = element.options[element.selectedIndex].value;
	
		//Obtenemos la extension
		element = document.getElementById('extension_newfile');
		//alert(select);
		var file_extension = element.options[element.selectedIndex].value;;
		
		//Creamos el nombre final del fichero
		var newfile_path = file_path+'/'+file_name+'.'+file_extension;
		
		//Comprobamos que no existe ya un fichero con ese nuevo nombre
		if (file_exists(newfile_path)) {
				var r = confirm("File exsists. Are you sure to overwrite this file?");
				if (r==true) {
					new_file(newfile_path);
				}
		}
		else {
			//Llamamos a la accion
			//rename_file(path_file, newpath_file);
			//Llamamos a la accion
			new_file(newfile_path);
		}
		
		//Llamamos a la accion
		//new_file(newfile_path);
	}
}



//Create folder window
function show_createfolder_window(path) {
	
}






//FUNCIONES AUXILIARES
//Obtiene del servidor el xml con las extensiones permitidas para este proyecto
function get_xmlextensions() {
	
	//var url = '../webdevstudio2_1/index.php';
	var url = 'ajax_extensions.php';
	var parameters = 'language='+encodeURIComponent(language);
	//alert(parameters);

	var ajaxobj = new AjaxEditor();
	var xml = ajaxobj.request_synchronous_xml(url, parameters);
	//alert(ajaxobj.request_synchronous_text(url, parameters));

	return xml;
}


//Obtiene del servidor el xml de la estructura de ficheros dado un path
function get_xmlfiletree(path) {
	
	//var url = '../webdevstudio2_1/index.php';
	var url = 'ajax_filetree.php';
	var parameters = 'path='+path;

	var ajaxobj = new AjaxEditor();
	var xml = ajaxobj.request_synchronous_xml(url, parameters);
	//alert(ajaxobj.request_synchronous_text(url, parameters));
	
	return xml;
}

//Obtiene el xml con las carpetas que estan en este path
function getFolderByPath(xml, path) {
	var folders = xml.getElementsByTagName('folder');

	for (var i=0; i<folders.length; i++) {
		if (unescape(folders[i].getAttribute('path')) == path) {
			return folders[i];
		}
	}
	
	return xml;
}
